
unit MainFrm;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.MultiView, FMX.Objects, FMX.TabControl,
  FMX.StdCtrls, FMX.Layouts, FMX.ListView.Types, FMX.ListView, FMX.ExtCtrls, FMX.Ani, FMX.Gestures, FMX.ListBox,
  FMX.DateTimeCtrls, FMX.Edit, FMX.MultiView.Types, FMX.Colors,
  FMX.EditBox, FMX.NumberBox, FMX.Controls.Presentation, FMX.Maps,
  FMX.ScrollBox, FMX.Memo, System.ImageList, FMX.ImgList;

type
  TFormMain = class(TForm)
    MultiView1: TMultiView;
    ToolBar1: TToolBar;
    MasterButton: TSpeedButton;
    ToolBar2: TToolBar;
    Label1: TLabel;
    Label2: TLabel;
    lbMainMenu: TListBox;
    lbiMapa: TListBoxItem;
    lbiPuntos: TListBoxItem;
    lbiPolygon: TListBoxItem;
    lbiMarcas: TListBoxItem;
    DetailPanel: TPanel;
    MasterButton2: TSpeedButton;
    tabControlMain: TTabControl;
    tsMap: TTabItem;
    MapView1: TMapView;
    tsPuntos: TTabItem;
    lbiMarca2: TListBoxItem;
    lbiTipo: TListBoxItem;
    lbiPolylineas: TListBoxItem;
    mmPuntosTest: TMemo;
    pnlBotones: TRectangle;
    btnIniciar: TButton;
    btnAcabar: TButton;
    btnParar: TButton;
    TimerPuntos: TTimer;
    ImageList1: TImageList;
    btnNormal: TButton;
    btnSatelite: TButton;
    btnHibrid: TButton;
    btnTerrain: TButton;
    TimerVisible: TTimer;
    TimerPoly: TTimer;
    btnAnimPoly: TButton;
    lbiLayerOptions: TListBoxItem;
    pnlLayerOptions: TRectangle;
    chkPOI: TCheckBox;
    chkBuilding: TCheckBox;
    chkUserLoc: TCheckBox;
    chkTraffic: TCheckBox;
    btnclose: TButton;
    Image1: TImage;
    TimerIcon: TTimer;
    IconAnimation: TFloatAnimation;
    procedure lbMainMenuItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
    procedure lbiMapaClick(Sender: TObject);
    procedure lbiPuntosClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lbiMarcasClick(Sender: TObject);
    procedure MultiView1StartShowing(Sender: TObject);
    procedure MultiView1StartHiding(Sender: TObject);
    procedure lbiMarca2Click(Sender: TObject);
    procedure btnIniciarClick(Sender: TObject);
    procedure btnPararClick(Sender: TObject);
    procedure btnAcabarClick(Sender: TObject);
    procedure TimerPuntosTimer(Sender: TObject);
    procedure btnTerrainClick(Sender: TObject);
    procedure lbiPolylineasClick(Sender: TObject);
    procedure lbiPolygonClick(Sender: TObject);
    procedure TimerVisibleTimer(Sender: TObject);
    procedure TimerPolyTimer(Sender: TObject);
    procedure btnAnimPolyClick(Sender: TObject);
    procedure lbiLayerOptionsClick(Sender: TObject);
    procedure chkPOIChange(Sender: TObject);
    procedure chkBuildingChange(Sender: TObject);
    procedure chkUserLocChange(Sender: TObject);
    procedure chkTrafficChange(Sender: TObject);
    procedure btncloseClick(Sender: TObject);
    procedure TimerIconTimer(Sender: TObject);
  private
    indexPunto:integer;
    // Marca posicional/movimiento
    posMarca:TMapCoordinate;
    descMarca:TMapMarkerDescriptor;
    Marca:TMapMarker;
    // Marca inicial
    //-- posInicial:TMapCoordinate;
    //-- descInicial:TMapMarkerDescriptor;
    Inicial:TMapMarker;
    // polylinea
    desCPoly: TMapPolylineDescriptor;
    mapPoly:TMapPolyline;
    puntosPoly: TArray<TMapCoordinate>;
    // Animacion
    puntoAnim:Integer;
    // Polygon
    descPolygon:TMapPolygonDescriptor;
    outLinePolygon:TMapPolygonPolyvertex;
    mapPolygon:TMapPolygon;
    visiblePoly:boolean;
    countAnim:integer;

    //Crear una marca en el mapa
    function CrearMarca(var pMap:TMapView; pLat, pLon:Double; pImgName:string;
                        pCentarMap:Boolean=False):TMapMarker;

    function GetBitmap(sBitmapName:string):TBitmap;
    // Calcular aprox. el punto centrar
    function CenterPolyline(arrPoints:TArray<TMapCoordinate>):TMapCoordinate;

    procedure Generar4Puntos(var arrPoints:TArray<TMapCoordinate>; pLat, pLon:Double);
  public
    { Public declarations }
  end;

const
  LAT_CAMPNOU = 41.37799995937444;
  LON_CAMPNOU = 2.1254360356903135;
  LAT_SAGRADA_FAMILIA = 41.4036299;
  LON_SAGRADA_FAMILIA = 2.1721671;

var
  FormMain: TFormMain;

implementation

uses
  System.StrUtils, FMX.MultiresBitmap,
  FMX.MultiView.Presentations;

{$R *.fmx}

procedure TFormMain.btnAnimPolyClick(Sender: TObject);
begin
  // Crear el array de puntyos
  puntosPoly := TArray<TMapCoordinate>.Create();
  puntoAnim := 0;
  // Iniciar
  TimerPoly.Enabled := true;
  //Cerrar el men
  MultiView1.HideMaster;
end;

procedure TFormMain.btncloseClick(Sender: TObject);
begin
  pnlLayerOptions.Visible := False;
end;

procedure TFormMain.btnIniciarClick(Sender: TObject);
begin
  // Iniciar
  TimerPuntos.Enabled := True;
  TimerPuntos.Interval := 200;
  indexPunto := 0;
  // Botones
  btnIniciar.Visible := False;
  btnParar.Visible:= True;
  btnAcabar.Visible:= True;
end;

procedure TFormMain.btnAcabarClick(Sender: TObject);
begin
  // Acabar
  TimerPuntos.Enabled := False;
  pnlBotones.Visible := False;
  // Botones
  btnParar.Visible:= False;
  btnAcabar.Visible:= False;
  btnIniciar.Visible:= True;
  // Liberar las marcas
  Marca.Remove;
  Inicial.Remove;

end;

procedure TFormMain.btnPararClick(Sender: TObject);
begin

  // Parar
  TimerPuntos.Enabled := not TimerPuntos.Enabled;
  if (TimerPuntos.Enabled) then
    btnParar.Text := 'Parar'
  else
    btnParar.Text := 'Seguir';

end;

procedure TFormMain.btnTerrainClick(Sender: TObject);
begin
  MapView1.MapType := TMapType(TControl(Sender).Tag);
  //Cerrar el men
  MultiView1.HideMaster;
end;

// Calcular aprox. el punto centrar
function TFormMain.CenterPolyline(arrPoints: TArray<TMapCoordinate>): TMapCoordinate;
var
  p:TMapCoordinate;
  tLat, tLon:Double;
  i, j:integer;
begin
  i := Length(ArrPoints);
  tLat := 0;
  tLon := 0;
  for j := Low(arrPoints) to High(ArrPoints) do begin
    tLat := tLat + arrPoints[j].Latitude;
    tLon := tLon + arrPoints[j].Longitude;
  end;
  Result.Latitude := tLat / i;
  Result.Longitude := tLon / i;
end;


procedure TFormMain.chkBuildingChange(Sender: TObject);
begin
  if (chkBuilding.IsChecked) then
    MapView1.LayerOptions := MapView1.LayerOptions + [TMapLayerOption.Buildings]
  else
    MapView1.LayerOptions := MapView1.LayerOptions - [TMapLayerOption.Buildings];
end;

procedure TFormMain.chkPOIChange(Sender: TObject);
begin
  if (chkPOI.IsChecked) then
    MapView1.LayerOptions := MapView1.LayerOptions + [TMapLayerOption.PointsOfInterest]
  else
    MapView1.LayerOptions := MapView1.LayerOptions - [TMapLayerOption.PointsOfInterest];
end;

procedure TFormMain.chkTrafficChange(Sender: TObject);
begin
  if (chkTraffic.IsChecked) then
    MapView1.LayerOptions := MapView1.LayerOptions + [TMapLayerOption.Traffic]
  else
    MapView1.LayerOptions := MapView1.LayerOptions - [TMapLayerOption.Traffic];
end;

procedure TFormMain.chkUserLocChange(Sender: TObject);
begin
  if (chkUserLoc.IsChecked) then
    MapView1.LayerOptions := MapView1.LayerOptions + [TMapLayerOption.UserLocation]
  else
    MapView1.LayerOptions := MapView1.LayerOptions - [TMapLayerOption.UserLocation];
end;

procedure TFormMain.FormShow(Sender: TObject);
var
  mapCenter:TMapCoordinate;
begin

  // Ini
  tabControlMain.ActiveTab := tsMap;
  tabControlMain.TabPosition := TTabPosition.None;
  // ini
  MultiView1.Mode := TMultiViewMode.Drawer;
  MultiView1.DrawerOptions.Mode := TSlidingMode.OverlapDetailView;
  TimerPuntos.Enabled := False;
  TimerVisible.Interval := 1000;
  // Ocultar componentes
  pnlBotones.Visible := False;
  pnlLayerOptions.Visible := False;
  // Botones
  btnParar.Visible:= False;
  btnAcabar.Visible:= False;

  // Centrar el mapa
  mapCenter := TMapCoordinate.Create(LAT_CAMPNOU, LON_CAMPNOU);
  MapView1.Location := mapCenter;
  MapView1.Zoom := 14;

end;


procedure TFormMain.lbiMapaClick(Sender: TObject);
begin
  tabControlMain.ActiveTab := tsMap;
end;

procedure TFormMain.lbiMarca2Click(Sender: TObject);
begin
  // panel de botones
  pnlBotones.Visible := True;

end;

procedure TFormMain.lbiMarcasClick(Sender: TObject);
var
  MarcaMapa:TMapMarker;
  descMarca:TMapMarkerDescriptor;
  posicion:TMapCoordinate;
begin
  // Posicion
  posicion := TMapCoordinate.Create(LAT_SAGRADA_FAMILIA, LON_SAGRADA_FAMILIA);
  // Crear Marker
  descMarca := TMapMarkerDescriptor.Create(posicion);
  descMarca.Icon := GetBitmap('imgMarca');
  descMarca.Draggable := False;
  descMarca.Opacity := 0.8;
  descMarca.Snippet := 'Antonio Gaud 1882';
  descMarca.Title := 'Sagrada familia';

  // Aadirla
  MarcaMapa := MapView1.AddMarker(descMarca);
  // Centrar el mapa en ese punto
  MapView1.Location := posicion;

end;

procedure TFormMain.lbiPuntosClick(Sender: TObject);
begin
  tabControlMain.ActiveTab := tsPuntos;
end;

procedure TFormMain.lbMainMenuItemClick(const Sender: TCustomListBox; const Item: TListBoxItem);
begin
  Item.IsSelected := False;
  MultiView1.HideMaster;
end;

procedure TFormMain.lbiLayerOptionsClick(Sender: TObject);
begin
  pnlLayerOptions.Visible := True;
end;

procedure TFormMain.Generar4Puntos(var arrPoints: TArray<TMapCoordinate>; pLat, pLon: Double);
const
  DELTA = 0.01;
var
  i:integer;
begin
  SetLength(outLinePolygon.Points, 5);
  arrPoints[0].Latitude := pLat - DELTA; arrPoints[0].Longitude := pLon - DELTA;
  arrPoints[1].Latitude := pLat + DELTA; arrPoints[1].Longitude := pLon - DELTA;
  arrPoints[2].Latitude := pLat + DELTA; arrPoints[2].Longitude := pLon + DELTA;
  arrPoints[3].Latitude := pLat - DELTA; arrPoints[3].Longitude := pLon + DELTA;

  arrPoints[4].Latitude := arrPoints[0].Latitude;
  arrPoints[4].Longitude := arrPoints[0].Longitude;
end;


procedure TFormMain.lbiPolygonClick(Sender: TObject);
var
  numPuntos:integer;
  dLat, dLon:Double;
  i:integer;
  center:TMapCoordinate;
begin

  // genera 4 punto alrededor de uno dado
  Generar4Puntos(outLinePolygon.Points, LAT_CAMPNOU, LON_CAMPNOU);

  // polygon (utilizamos los puntos de test
  descPolygon := TMapPolygonDescriptor.Create(outLinePolygon.Points);
  // Caracteristicas
  descPolygon.StrokeColor := TAlphaColorRec.Red;
  descPolygon.StrokeWidth := 6;
  descPolygon.Geodesic := True;
  descPolygon.ZIndex := 0.5;
  descPolygon.FillColor := TAlphaColorRec.Yellow;
  // Aadirla al mapa
  mapPolygon := MapView1.AddPolygon(descPolygon);
  // centrar el mapa (calculado aprox. a partir de los puntos)
  MapView1.Location := CenterPolyline(outLinePolygon.Points);

  TimerVisible.Enabled := True;
  countAnim := 0;


  // --------------------------------------------------------


  Exit;

  //
  i := 5;

  // Creamos el polgono con varios puntos de la ruta
  SetLength(outLinePolygon.Points, i);
  // Coordenadas
  dLat := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.Names[0], '.', ','), 0);
  dLon := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.ValueFromIndex[0], '.', ','), 0);
  outLinePolygon.Points[0].Latitude := dLat;
  outLinePolygon.Points[0].Longitude := dLon;

  dLat := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.Names[500], '.', ','), 0);
  dLon := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.ValueFromIndex[500], '.', ','), 0);
  outLinePolygon.Points[1].Latitude := dLat;
  outLinePolygon.Points[1].Longitude := dLon;

  dLat := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.Names[700], '.', ','), 0);
  dLon := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.ValueFromIndex[700], '.', ','), 0);
  outLinePolygon.Points[2].Latitude := dLat;
  outLinePolygon.Points[2].Longitude := dLon;

  dLat := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.Names[1000], '.', ','), 0);
  dLon := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.ValueFromIndex[1000], '.', ','), 0);
  outLinePolygon.Points[3].Latitude := dLat;
  outLinePolygon.Points[3].Longitude := dLon;

  dLat := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.Names[1200], '.', ','), 0);
  dLon := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.ValueFromIndex[1200], '.', ','), 0);
  outLinePolygon.Points[4].Latitude := dLat;
  outLinePolygon.Points[4].Longitude := dLon;

  // Aadimos al final el punto inicial, para cerrarlo
  Inc(i);
  SetLength(outLinePolygon.Points, i);
  outLinePolygon.Points[i-1].Latitude := outLinePolygon.Points[0].Latitude;
  outLinePolygon.Points[i-1].Longitude := outLinePolygon.Points[0].Longitude;

  // polygon (utilizamos los puntos de test
  descPolygon := TMapPolygonDescriptor.Create(outLinePolygon.Points);
  // Caracteristicas
  descPolygon.StrokeColor := TAlphaColorRec.Red;
  descPolygon.StrokeWidth := 6;
  descPolygon.Geodesic := True;
  descPolygon.ZIndex := 0.5;
  descPolygon.FillColor := TAlphaColorRec.Yellow;
  // Aadirla al mapa
  mapPolygon := MapView1.AddPolygon(descPolygon);
  // centrar el mapa (calculado aprox. a partir de los puntos)
  MapView1.Location := CenterPolyline(outLinePolygon.Points);

  TimerVisible.Enabled := True;
  countAnim := 0;

end;

procedure TFormMain.lbiPolylineasClick(Sender: TObject);
var
  numPuntos:integer;
  dLat, dLon:Double;
  i:integer;
  center:TMapCoordinate;
begin

  // Crear el array de puntyos
  puntosPoly := TArray<TMapCoordinate>.Create();
  SetLength(puntosPoly, mmPuntosTest.Lines.Count);
  // Aadir los puntos
  for i := 0 to (mmPuntosTest.Lines.Count - 1) do begin
    // Coordenadas
    dLat := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.Names[i], '.', ','), 0);
    dLon := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.ValueFromIndex[i], '.', ','), 0);
    // Aadir el punto
    if (dLat <> 0) and (dLon <> 0) then begin
      puntosPoly[i].Latitude := dLat;
      puntosPoly[i].Longitude := dLon;
    end;
  end;

  // polylineas (utilizamos los puntos de test
  descPoly := TMapPolylineDescriptor.Create(puntosPoly);
  // Caracteristicas
  descPoly.StrokeColor := TAlphaColorRec.Red;
  descPoly.StrokeWidth := 6;
  descPoly.Geodesic := True;
  descPoly.ZIndex := 0.5;
  // Aadirla al mapa
  mapPoly := MapView1.AddPolyline(descPoly);
  // centrar el mapa (calculado aprox. a partir de los puntos)
  MapView1.Location := CenterPolyline(puntosPoly);

  // Crear marcas de inicio y final
  CrearMarca(MapView1, puntosPoly[0].Latitude, puntosPoly[0].Longitude, 'imgBandera');
  CrearMarca(MapView1, puntosPoly[i-1].Latitude, puntosPoly[i-1].Longitude, 'imgFinish');
end;

procedure TFormMain.MultiView1StartHiding(Sender: TObject);
begin
  MapView1.Visible := True;
end;

procedure TFormMain.MultiView1StartShowing(Sender: TObject);
begin
  MapView1.Visible := False;
  // Paneles
  pnlBotones.Visible := False;
  pnlLayerOptions.Visible := False;
end;


function TFormMain.GetBitmap(sBitmapName: string):TBitmap;
var
  Item:TCustomBitmapItem;
  tam:TSize;
begin
  ImageList1.BitmapItemByName(sBitmapName, Item, tam);
  Result := Item.MultiResBitmap.Bitmaps[1.0];
end;


procedure TFormMain.TimerIconTimer(Sender: TObject);
begin
  IconAnimation.Start;
end;

procedure TFormMain.TimerPolyTimer(Sender: TObject);
var
  center:TMapCoordinate;
  totPuntos:Integer;
  dLat, dLon:Double;
begin
  // Total de puntos
  totPuntos := mmPuntosTest.Lines.Count;
  Inc(puntoAnim);

  if (puntoAnim < totPuntos) then begin
    // longiotud del array
    SetLength(puntosPoly, puntoAnim);
    // Coordenadas
    dLat := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.Names[puntoAnim], '.', ','), 0);
    dLon := StrToFloatDef(AnsiReplaceText(mmPuntosTest.Lines.ValueFromIndex[puntoAnim], '.', ','), 0);
    // Aadir el punto
    if (dLat <> 0) and (dLon <> 0) then begin
      puntosPoly[puntoAnim-1].Latitude := dLat;
      puntosPoly[puntoAnim-1].Longitude := dLon;
    end;
  end
  else begin
    // acabar
    TimerPoly.Enabled := false;
  end;

  //
  if (puntoAnim = 1) then begin
    // polylineas (utilizamos los puntos de test
    descPoly := TMapPolylineDescriptor.Create(puntosPoly);
    // Caracteristicas
    descPoly.StrokeColor := TAlphaColorRec.Red;
    descPoly.StrokeWidth := 6;
    descPoly.Geodesic := True;
    descPoly.ZIndex := 0.5;
    // Aadirla al mapa
    mapPoly := MapView1.AddPolyline(descPoly);

    // Marcas iniciales ========================================
    CrearMarca(MapView1, dLat, dLon, 'imgBandera');
    {posInicial := TMapCoordinate.Create(dLat, dLon);
    // Crear Marker
    descInicial := TMapMarkerDescriptor.Create(posInicial);
    descInicial.Icon := GetBitmap('imgBandera');
    descInicial.Draggable := False;
    // Aadirla
    MapView1.AddMarker(descInicial);}


    // Marca para mover  =========================================
    posMarca := TMapCoordinate.Create(dLat, dLon);
    // Crear Marker
    descMarca := TMapMarkerDescriptor.Create(posMarca);
    descMarca.Icon := GetBitmap('imgBici');
    descMarca.Draggable := False;
    // Aadirla
    Marca := MapView1.AddMarker(descMarca);
  end
  else if ((puntoAnim mod 50) = 0) then begin
    descPoly.Points.Points := puntosPoly;
    // mapPoly.Remove;
    mapPoly := MapView1.AddPolyline(descPoly);

    // Marca de posicion =========================================
    // la eliminamos y creamos la nueva
    Marca.Remove;
    // Posicion
    posMarca.Latitude := dLat;
    posMarca.Longitude := dLon;
    descMarca.Position.Latitude := posMarca.Latitude;
    descMarca.Position.Longitude := posMarca.Longitude;
    // centrar el mapa
    MapView1.Location := posMarca;
    // Volver a colocarla
    Marca := MapView1.AddMarker(descMarca);
  end;



  // cada 50 puntos centramos el mapa
  if ((puntoAnim mod 50) = 0) then begin
    // MapView1.Location := CenterPolyline(puntosPoly);
    MapView1.Location := CenterPolyline(puntosPoly);
  end
  else if (puntoAnim = 1) then begin
    // centrar el mapa (calculado aprox. a partir de los puntos)
    center := TMapCoordinate.Create(dLat, dLon);
    MapView1.Location := center;
  end;
end;

function TFormMain.CrearMarca(var pMap:TMapView; pLat, pLon:Double; pImgName:string; pCentarMap:Boolean=False):TMapMarker;
var
  pos:TMapCoordinate;
  desc:TMapMarkerDescriptor;
begin
  pos := TMapCoordinate.Create(pLat, pLon);
  //Centrar el mapa
  if (pCentarMap) then    pMap.Location := pos;
  // Crear Marker
  desc := TMapMarkerDescriptor.Create(pos);
  desc.Icon := GetBitmap(pImgName);
  desc.Draggable := False;
  // Aadirla
  Result := pMap.AddMarker(desc);



    {posMarca := TMapCoordinate.Create(dLat, dLon);
    // centrar el mapa
    MapView1.Location := posMarca;
    // Crear Marker
    descMarca := TMapMarkerDescriptor.Create(posMarca);
    descMarca.Icon := GetBitmap('imgCorrer');
    descMarca.Draggable := False;
    // Aadirla
    Marca := MapView1.AddMarker(descMarca);
    }



end;



procedure TFormMain.TimerPuntosTimer(Sender: TObject);
var
  numPuntos:integer;
  dLat, dLon:Double;
begin
  // ini
  numPuntos := mmPuntosTest.Lines.Count;
  // Coordenadas
  dLat := StrToFloat(AnsiReplaceText(mmPuntosTest.Lines.Names[indexPunto], '.', ','));
  dLon := StrToFloat(AnsiReplaceText(mmPuntosTest.Lines.ValueFromIndex[indexPunto], '.', ','));

  // Crear la marca para el movimiento
  if (indexPunto = 0) then begin
    // Marca inicial =========================================
    Inicial := CrearMarca(MapView1, dLat, dLon, 'imgBandera', True);

    // Marca para mover  =========================================
    posMarca := TMapCoordinate.Create(dLat, dLon);
    // centrar el mapa
    MapView1.Location := posMarca;
    // Crear Marker
    descMarca := TMapMarkerDescriptor.Create(posMarca);
    descMarca.Icon := GetBitmap('imgCorrer');
    descMarca.Draggable := False;
    // Aadirla
    Marca := MapView1.AddMarker(descMarca);
  end
  else begin
    // la eliminamos y creamos la nueva
    Marca.Remove;
    // Posicion
    posMarca.Latitude := dLat;
    posMarca.Longitude := dLon;
    descMarca.Position.Latitude := posMarca.Latitude;
    descMarca.Position.Longitude := posMarca.Longitude;
    // centrar el mapa
    MapView1.Location := posMarca;
    // Volver a colocarla
    Marca := MapView1.AddMarker(descMarca);
  end;

  // Incrementamos el indice
  Inc(indexPunto);

end;

procedure TFormMain.TimerVisibleTimer(Sender: TObject);
begin
  mapPolygon.SetVisible(visiblePoly);
  visiblePoly := not visiblePoly;
  inc(countAnim);
  TimerVisible.Enabled := (countAnim < 8);


end;

end.
